<?php
/**
 * KodExplorer 去除统计、更新提示与版权校验代码
 * 已测试支持版本：4.47
 */

function getExtendCode($content, $part, $n = 1){
	$length = strlen($content);
	$start = strpos($content, $part);
	if($start===false)return false;
	$end = $start+strlen($part);
	$c = 0;
	for($i=$start;$i>=0;$i--){
		if(substr($content,$i,1) == '{') $c++;
		if(substr($content,$i,1) == '}') $c--;
		if($c == $n){
			$start = $i;
			break;
		}
	}
	$c = 0;
	for($i=$end;$i<=$length;$i++){
		if(substr($content,$i,1) == '}') $c++;
		if(substr($content,$i,1) == '{') $c--;
		if($c == $n){
			$end = $i;
			break;
		}
	}
	return substr($content, $start, $end - $start + 1);
}

function checkdir($basedir){
    if($dh=opendir($basedir)){
        while (($file=readdir($dh)) !== false){
            if($file != '.' && $file != '..'){
                if(!is_dir($basedir.'/'.$file) && substr($file,-3)=='.js'){
                    handlefile($basedir.'/'.$file);
                }else{
                    $dirname=$basedir.'/'.$file;
                    checkdir($dirname);
                }
            }
        }
        closedir($dh);
    }
}

function handlefile($filepath){
	$file = file_get_contents($filepath);
	if(!$file)return;

	preg_match_all('/n\[[a-zA-Z0-9]+\]\([a-zA-Z0-9],function\(n\){.+?;try{n\[[a-zA-Z0-9]+\]\([a-zA-Z0-9]{0,}?\)}catch\([a-zA-Z0-9]\){}}\)/',$file,$matchs);
	$code = [];
	foreach($matchs[0] as $line){
		$new = getExtendCode($file, $line, 1);
		if(!in_array($new, $code)) $code[] = $new;
	}
	preg_match_all('/for\(var n=\[[a-zA-Z0-9\[\]\(\)\$,]+\],[a-zA-Z0-9]=[a-zA-Z0-9];[a-zA-Z0-9]<n\[[a-zA-Z0-9]+\];[a-zA-Z0-9]\+\+\)/',$file,$matchs);
	foreach($matchs[0] as $line){
		$code[] = getExtendCode($file, $line, 1);
	}
	$code[] = getExtendCode($file, 'todo()', 3);
	$code[] = getExtendCode($file, 'todo("2-1")', 3);

	foreach($code as $line){
		if($line)
			$file = str_replace($line,'{}',$file);
	}

	if(file_put_contents($filepath, $file)){
		echo '文件：'.$filepath.' <font color=green>处理成功</font><br/>';
	}else{
		echo '文件：'.$filepath.' <font color=red>处理失败，可能无写入权限</font><br/>';
	}
}

function handleztreefile($filepath){
	$file = file_get_contents($filepath);
	if(!$file)return;

	$code = getExtendCode($file, 'authCrypt', 3);
	if($code) $file = str_replace($code,'{}',$file);

	if(file_put_contents($filepath, $file)){
		echo '文件：'.$filepath.' <font color=green>处理成功</font><br/>';
	}else{
		echo '文件：'.$filepath.' <font color=red>处理失败，可能无写入权限</font><br/>';
	}
}

if(!file_exists('./static/js/app/src'))exit('当前目录不存在KodExplorer程序文件');
checkdir('./static/js/app/src');
handleztreefile('./static/js/lib/ztree/ztree.js');
